# FilePaths.jl

[![Build Status](https://github.com/rofinn/FilePaths.jl/workflows/CI/badge.svg)](https://github.com/rofinn/FilePaths.jl/actions)
[![codecov.io](https://codecov.io/github/rofinn/FilePaths.jl/coverage.svg?branch=master)](https://codecov.io/rofinn/FilePaths.jl?branch=master)

[FilePathsBase.jl](https://github.com/rofinn/FilePathsBase.jl) provides a type based API for working with filesystem paths.
Please review the FilePathsBase [docs](https://rofinn.github.io/FilePathsBase.jl/stable/) for more info on working with the base filepath types.
FilePaths.jl extends FilePathsBase to provide easier interoperability with the rest of the Julia ecosystem.

## Intallation:
FilePaths.jl is registered, so you can to use `Pkg.add` to install it.

```julia
julia> Pkg.add("FilePaths")
```

## Usage:
```julia
julia> using FilePaths; using FilePathsBase: /
```

Globbing files:
```julia
julia> using Glob

julia> glob("*test*.jl", p"test")
2-element Array{PosixPath,1}:
 p"test/runtests.jl"
 p"test/test_uri.jl"
```

URIParsing:
```julia
julia> using URIs

julia> URI(cwd() / p"test/runtests.jl")
URI("file:///Users/rory/repos/FilePaths.jl/test/runtests.jl")
```

Writing `String` and `AbstractPath` compatible code:

```julia
julia> FilePaths.@compat function myrelative(x::AbstractPath, y::AbstractPath)
           return relative(x, y)
       end
myrelative (generic function with 2 methods)

julia> FilePaths.@compat function myjoin(x::P, y::String)::P where P <: AbstractPath
           return x / y
       end
myjoin (generic function with 2 methods)

julia> myrelative(cwd(), home())
p"repos/FilePaths.jl"

julia> myrelative(pwd(), homedir())
p"repos/FilePaths.jl"

julia> myjoin(parent(cwd()), "FilePaths.jl")
p"/Users/rory/repos/FilePaths.jl"

julia> myjoin("/Users/rory/repos", "FilePaths.jl")
"/Users/rory/repos/FilePaths.jl"
```

using .URIs

const absent = SubString("absent", 1, 0)

function URIs.URI(p::AbstractPath; query=absent, fragment=absent)
    if isempty(p.root)
        throw(ArgumentError("$p is not an absolute path"))
    end

    b = IOBuffer()
    print(b, "file://")

    if !isempty(p.drive)
        print(b, "/")
        print(b, p.drive)
    end

    for s in p.segments
        print(b, "/")
        print(b, URIs.escapeuri(s))
    end

    return URIs.URI(URIs.URI(String(take!(b))); query=query, fragment=fragment)
end

"""
    FilePaths.@compat fn

Generates a compatibility method for handling paths as strings based on the function
definition passed in.

Wrapper method properties:

- Any arguments that accepted `P <: AbstractPath` will accept `Union{String, P}`
- All string path inputs will be converted to path types
- If a path return type was specified then the path result will be converted back to a string.

# Examples

```
julia> using FilePathsBase; using FilePathsBase: /; using FilePaths

julia> FilePaths.@compat function myrelative(x::AbstractPath, y::AbstractPath)
           return relative(x, y)
       end
myrelative (generic function with 2 methods)

julia> FilePaths.@compat function myjoin(x::P, y::String)::P where P <: AbstractPath
           return x / y
       end
myjoin (generic function with 2 methods)

julia> myrelative(cwd(), home())
p"repos/FilePaths.jl"

julia> myrelative(pwd(), homedir())
p"repos/FilePaths.jl"

julia> myjoin(parent(cwd()), "FilePaths.jl")
p"/Users/rory/repos/FilePaths.jl"

julia> myjoin("/Users/rory/repos", "FilePaths.jl")
"/Users/rory/repos/FilePaths.jl"
```
"""
macro compat(ex)
    mod::Module = QuoteNode(__module__).value
    new_ex = compat_exp(mod, deepcopy(ex))

    return quote
        $ex
        $new_ex
    end |> esc
end

function compat_exp(mod::Module, ex::Expr)
    fdef = splitdef(ex)
    args = Symbol[]
    kwargs = Expr[]
    convert_vars = Symbol[]
    body = Expr[]
    params = Symbol[]

    # A function that identifies args that need to be converted
    function parse_arg(a)
        if a.args[2] in params
            push!(convert_vars, a.args[1])
        elseif _ispath(mod, a.args[2])
            # Modify the arg type declaration from P<:AbstractPath to Union{String, P}
            # NOTE: If the variable is parameterized then we should have already updated the
            # parameterized type in the where clause
            a.args[2] = :(Union{AbstractString, $(a.args[2])})
            push!(convert_vars, a.args[1])
        end
    end

    # Identify any where params that are a subtype of AbstractPath
    if haskey(fdef, :whereparams)
        for (i, p) in enumerate(fdef[:whereparams])
            # If the param is a subtype of AbstracPath
            # then we store the lookup symbol in the params array
            if _ispath(mod, p.args[2])
                # Modify parameterized where clause from P<:AbstractPath to Union{String, P}
                p.args[2] = :(Union{AbstractString, $(p.args[2])})
                push!(params, p.args[1])
            end
        end
    end

    # Identify args that need to be converted
    if haskey(fdef, :args)
        for (i, a) in enumerate(fdef[:args])
            # An arg can be an expression or a symbol (no type information)
            if isa(a, Expr)
                if (a.head) === :kw
                    # Optional arguments show up as `kw` and need to be parsed as such
                    T = a.args[1]
                    parse_arg(T)
                    push!(args, T.args[1])
                else
                    parse_arg(a)
                    push!(args, a.args[1])
                end
            elseif isa(a, Symbol)
                push!(args, a)
            else
                throw(ArgumentError("Uknown argument type $a"))
            end
        end
    end

    # Identify kwargs that need to be converted
    if haskey(fdef, :kwargs)
        for (i, k) in enumerate(fdef[:kwargs])
            T = k.args[1]
            parse_arg(T)
            # Rewrite the kwarg expression to pass them along
            push!(kwargs, :($(T.args[1])=$(T.args[1])))
        end
    end

    # Insert our convert statements for the appropriate variables
    for v in convert_vars
        push!(body, :($v = Path($v)))
    end

    # Push our paths method call into the body
    push!(body, :(result = $(fdef[:name])($(args...); $(kwargs...))))

    # If we have a return type and it's a path then convert the result back to a string
    if haskey(fdef, :rtype) && (fdef[:rtype] in params || _ispath(mod, fdef[:rtype]))
        push!(body, :(result = string(result)))
        # Set the return type to String to avoid an incorrect conversion back to a path
        fdef[:rtype] = :String
    end

    # Finally, insert a return statement
    push!(body, :(return result))

    # Update our definition with the new body
    fdef[:body].args = body

    # Combine the modified definition back into an expression
    return MacroTools.combinedef(fdef)
end

function _ispath(mod::Module, t::Symbol)
    T = getfield(mod, t)
    return T <: AbstractPath
end

module FilePaths

using MacroTools
using Reexport
using Requires

@reexport using FilePathsBase

include("compat.jl")

function __init__()
    @require Glob="c27321d9-0574-5035-807b-f59d2c89b15c" include("glob.jl")
    @require URIParser="30578b45-9adc-5946-b283-645ec420af67" include("uriparser.jl")
    @require URIs="5c2747f8-b7ea-4ff2-ba2e-563bfd36b1d4" include("uris.jl")
end

end # end of module

using .URIParser

function URIParser.URI(p::AbstractPath; query="", fragment="")
    Base.depwarn("`URIParser` is deprecated, use `URIs` instead.", :URIParser)
    if isempty(p.root)
        throw(ArgumentError("$p is not an absolute path"))
    end

    b = IOBuffer()
    print(b, "file://")

    if !isempty(p.drive)
        print(b, "/")
        print(b, p.drive)
    end

    for s in p.segments
        print(b, "/")
        print(b, URIParser.escape(s))
    end

    return URIParser.URI(URIParser.URI(String(take!(b))); query=query, fragment=fragment)
end

using URIParser
using URIs
using FilePaths

@testset "URIParser" begin
    @test string(URIParser.URI(p"/foo/bar")) == "file:///foo/bar"
    @test string(URIParser.URI(p"/foo foo/bar")) == "file:///foo%20foo/bar"
    @test_throws ArgumentError URIParser.URI(p"foo/bar")
    @test string(URIParser.URI(WindowsPath("C:\\foo\\bar"))) == "file:///C:/foo/bar"
    @test string(URIParser.URI(p"/foo/bar", query="querypart", fragment="fragmentpart")) == "file:///foo/bar?querypart#fragmentpart"
end

@testset "URIs" begin
    @test string(URIs.URI(p"/foo/bar")) == "file:///foo/bar"
    @test string(URIs.URI(p"/foo foo/bar")) == "file:///foo%20foo/bar"
    @test_throws ArgumentError URIs.URI(p"foo/bar")
    @test string(URIs.URI(WindowsPath("C:\\foo\\bar"))) == "file:///C:/foo/bar"
    @test string(URIs.URI(p"/foo/bar", query="querypart", fragment="fragmentpart")) == "file:///foo/bar?querypart#fragmentpart"
end

using .Glob
using .Glob: GlobMatch

Base.readdir(pattern::GlobMatch, prefix::AbstractPath) = glob(pattern, prefix)

function Glob.glob(pattern, prefix::T) where T<:AbstractPath
    return [parse(T, m) for m in glob(pattern, string(prefix))]
end

module TestPkg

using FilePathsBase
using FilePathsBase: /
using FilePaths

# Test for basic definitions taking abstract paths
FilePaths.@compat function typical(x::AbstractPath, y::AbstractPath)
    return relative(x, y)
end

# Test for definition taking parameterized paths
FilePaths.@compat function parameterized(x::P, y::P) where P <: AbstractPath
    return relative(x, y)
end

# Test for definition with a path return type
# (indicating that we should convert it back to a string)
FilePaths.@compat function rtype(x::P, y::P)::P where P <: AbstractPath
    return relative(x, y)
end

# Test for a mixed input definition
# z is an unused variable to make sure untyped variables don't break the macro
FilePaths.@compat function mixed(x::P, y::String, z)::P where P <: AbstractPath
    return x / y
end

# Test kwargs
FilePaths.@compat function kwargs(x::AbstractPath; y::AbstractPath=cwd())::AbstractPath
    return relative(x, y)
end

# Test optional args
FilePaths.@compat function optargs(x::AbstractPath, y::AbstractPath=cwd())::AbstractPath
    return relative(x, y)
end

# Test for inline definitions
FilePaths.@compat inline(x::AbstractPath, y::AbstractPath) = relative(x, y)


# Test for custom path type
struct MyPath <: AbstractPath
    x::String
end

__init__() = FilePathsBase.register(MyPath)
function Base.tryparse(::Type{MyPath}, str::AbstractString)
    startswith(str, "mypath://") ? MyPath(str) : nothing
end

FilePaths.@compat mypath_testem(path::MyPath) = "**"*path.x

end  # TestPkg module

@testset "@compat" begin
    cd(absolute(parent(Path(@__FILE__)))) do
        reg = Sys.iswindows() ? "..\\src\\FilePaths.jl" : "../src/FilePaths.jl"
        @test ispath(reg)
        p = Path(reg)

        @testset "typical" begin
            # Passing paths should should work just like calling relative
            @test TestPkg.typical(p, home()) == relative(p, home())

            # Passing strings should now also work just like calling relative
            @test TestPkg.typical(string(p), string(home())) == relative(p, home())

            # Mixing strings and paths should also work here
            @test TestPkg.typical(string(p), home()) == relative(p, home())
        end

        @testset "parameterized" begin
            # Passing paths should should work just like calling relative
            @test TestPkg.parameterized(p, home()) == relative(p, home())

            # Passing strings should now also work just like calling relative
            @test TestPkg.parameterized(string(p), string(home())) == relative(p, home())

            # Mixing strings and paths should error because x and y need to be the same type
            @test_throws MethodError TestPkg.parameterized(string(p), home())
        end

        @testset "rtype" begin
            # Passing paths should should work just like calling relative
            @test TestPkg.rtype(p, home()) == relative(p, home())

            # Passing strings should also convert the output to a string
            @test TestPkg.rtype(string(p), string(home())) == string(relative(p, home()))

            # Mixing strings and paths should error because x and y need to be the same type
            @test_throws MethodError TestPkg.rtype(string(p), home())
        end

        @testset "mixed" begin
            # Passing in a path as the first argument should return the same output as p / home()
            prefix = parent(p)
            suffix = basename(p)
            @test TestPkg.mixed(prefix, suffix, 2) == p

            # Passing 2 strings should also convert the output to a string
            @test TestPkg.mixed(string(prefix), suffix, 2) == string(p)

            # Passing a path where we explicitly want a string will error
            @test_throws MethodError TestPkg.mixed(prefix, Path(suffix), 2)
        end

        @testset "optargs" begin
            # Passing paths should should work just like calling relative
            @test TestPkg.optargs(p, home()) == relative(p, home())

            # Passing strings should also return the relative path as a string
            @test TestPkg.optargs(string(p), string(home())) == string(relative(p, home()))

            # With optional arguments we should be able to mix strings on either argument
            @test TestPkg.optargs(p, string(home())) == string(relative(p, home()))
            @test TestPkg.optargs(string(p), home()) == string(relative(p, home()))

            # Use default
            @test TestPkg.optargs(p) == relative(p, cwd())
            @test TestPkg.optargs(string(p)) == string(relative(p, cwd()))
        end

        @testset "inline" begin
            # Passing paths should should work just like calling relative
            @test TestPkg.inline(p, home()) == relative(p, home())

            # Passing strings should now also work just like calling relative
            @test TestPkg.inline(string(p), string(home())) == relative(p, home())

            # Mixing strings and paths should also work here
            @test TestPkg.inline(string(p), home()) == relative(p, home())
        end

        @testset "Custom path type" begin
            @test TestPkg.mypath_testem(TestPkg.MyPath("mypath://foo")) == "**mypath://foo"
            @test TestPkg.mypath_testem("mypath://foo") == "**mypath://foo"
        end
    end
end
